package cn.sagacloud.cadengine

import android.Manifest
import android.content.pm.PackageManager
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.support.v4.app.ActivityCompat
import android.support.v4.content.ContextCompat
import cn.sagacloud.android.cadengine.FloorScene
import kotlinx.android.synthetic.main.activity_main.*
import org.jetbrains.anko.doAsync
import org.jetbrains.anko.uiThread

class MainActivity : AppCompatActivity() {
    val scene = FloorScene()
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        addPermission()
        graphyView.scene = scene

        /** 开启异步 */
        doAsync {
            scene.loadUrl("http://192.168.20.215:9001/image-service/common/file_get?systemId=revit&key=base/2e179188dec911e9a6adaf571308f9a0.jsonz")
            //scene.loadUrl("http://api.sagacloud.cn/dp-auxiliary/image-service/common/file_get?systemId=revit&key=Fl42010500018b580334dcf111e8a553db1eadfac99320190803114958bim.jsonz")
            /** 主线程处理ui */
            uiThread {
                /** 适应屏幕大小 */
                graphyView.fitSceneToView()
                /** 限定移动范围不超出屏幕 */
                graphyView.moveRange()
            }
        }
    } // Function onCreate()

    companion object {
        val CODE_PERMISSION = 1604
        private val CODE_DOWNLOAD = 1808
        private val CODE_CLEAR = 1911
    }

    /**
     * Desc: 动态请求权限
     * Created by mengxy
     * Mail: mengxiangyong@persagy.com
     * 2018/3/29 15:08
     */
    private fun addPermission() {
        val isAllGranted = checkPermissionAllGranted(
                arrayOf(Manifest.permission.WRITE_EXTERNAL_STORAGE,
                        Manifest.permission.READ_EXTERNAL_STORAGE,
                        Manifest.permission.CAMERA,
                        Manifest.permission.RECORD_AUDIO)
        )
        if (!isAllGranted) {
            ActivityCompat.requestPermissions(
                    this,
                    arrayOf(Manifest.permission.WRITE_EXTERNAL_STORAGE,
                            Manifest.permission.READ_EXTERNAL_STORAGE,
                            Manifest.permission.CAMERA,
                            Manifest.permission.RECORD_AUDIO),
                    CODE_PERMISSION
            )
        }
    }

    /**
     * 检查是否拥有指定的所有权限
     */
    private fun checkPermissionAllGranted(permissions: Array<String>): Boolean {
        // 只要有一个权限没有被授予, 则直接返回 false
        return permissions.none { ContextCompat.checkSelfPermission(this, it) != PackageManager.PERMISSION_GRANTED }
    }
} // Class MainActivity
